<template>
<!--  <el-dialog title="收货地址" :visible.sync="dialogFormVisible">-->
  <el-container>
    <el-header style="width: 100%; height: 80px;font-size: 12px">

      <el-form :inline="true"  label-width="65px"  label-position="left">
        <el-row>

          <el-col :span="22">
            <el-form-item label="单位编码:">
              <el-select v-model="request.dwbm" filterable  placeholder="单位编码" clearable   :disabled="this.flag" >
                <!--              <el-select v-model="queryParam.xqdw" filterable  placeholder="需求部门" clearable   >-->
                <el-option
                  v-for="item in dictData.xqdws"
                  :key="item.bm"
                  :label="item.mc"
                  :value="item.bm">
                </el-option>
              </el-select>
            </el-form-item>
            <el-form-item label="车间名称:">
              <el-input v-model="request.cjmc" type="search" placeholder="车间名称" ></el-input>
            </el-form-item>
            <el-form-item label="场地名称:">
              <el-input v-model="request.cdmc" type="search" placeholder="场地名称" ></el-input>
            </el-form-item>


          </el-col>
          <el-col :span="2">
            <el-form-item style="float: right" >
              <el-button type="success" @click="initList">查询</el-button>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="10" :offset="14">
            <el-form-item style="float: right" >

          <el-button
            type="success"
            @click="toolbarButtonClickEvent('save')"
          >保存</el-button>
          <el-button type="success" @click="toolbarButtonClickEvent('insert')">添加</el-button>
          <el-button
            type="danger"
            @click="toolbarButtonClickEvent('delete')"
          >删除
          </el-button>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-header>
    <el-container  style="padding-top: 0px">
      <el-container>
        <el-main>
          <div class="mytable">
            <vxe-grid
              id="id"
              ref="xGrid"
              border
              resizable
              keep-source
              :align="'center'"
              :height="height"
              :auto-resize="true"
              :columns="tableColumn"
              highlight-current-row
              :data="list"
              :custom-config="{ storage: true }"
              :edit-config="{ trigger: 'click', mode: 'cell', showStatus: true}"
              highlight-hover-row
              @edit-actived="editActivedEvent"
              show-overflow
              show-header-overflow

            />
          </div>


        </el-main>
      </el-container>
    </el-container>
  </el-container>
</template>

<script>
import {
  getXqdwcjcdList,
  updateXqdwcjcd,
  delXqdwcjcd,
  saveXqdwcjcd,
} from '@/api/fd/jc'
import {
 getTpBase
} from '@/api/fd/base'
import { mapGetters } from 'vuex'
import XEUtils from 'xe-utils'
import {null2str} from "@/utils/rpkj";
export default {
  name:'xqdwcjcd',
  data() {
    return {
      request: {
        dwbm:'',
        cjmc:'',
        cdmc:''

      },
      list: [],
      deptList: [],
      clickList: [],

      dictData:{},
      height: '500px',

      tableColumn: [
        { type: 'checkbox', width: 50 ,
        },
        { type: 'seq', width: 60, title: '序号' },

        { field: 'dwbm', title: '单位编码', width: 120,
          editRender: { name: '$select', options: [],
            optionProps: { value: 'bm', label: 'mc' },
            props: { clearable: true },events: { change: this.selectChange },
          },
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'cjmc', title: '车间名称', width: 120, editRender: { name: 'input' },
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'cdmc', title: '场地名称', width: 120, editRender: { name: 'input' },
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'fzry', title: '负责人', width: 120, editRender: { name: 'input' },
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'tel', title: '电话', width: 120, editRender: { name: 'input' },
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },
        { field: 'bz', title: '备注', width: 120, editRender: { name: 'input' },
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination', },
        },

      ]
    }
  },
  computed: {
    ...mapGetters(['name', 'bmbm','apbm'])
  },
  created() {
    window.addEventListener('resize', this.getHeight)
    this.getHeight()
    this.initBase()
    if(this.apbm==='P30000'){
      this.request.dwbm='P30000'
      this.flag=true;
    }else{
      this.flag=false;
    }

  },
  methods: {






    initBase(){
      // getTpBase({}).then(res=>{
      //   this.dictData = res.data
      //   const xGrid = this.$refs.xGrid
      //
      //   const dwbm = xGrid.getColumnByField('dwbm')
      //   dwbm.editRender.options = res.data.xqdws
      //
      // })
    },
    initList() {
      getXqdwcjcdList(this.request).then((res) => {
        this.list = res.data
        if (this.$refs.xGrid) {
          this.$refs.xGrid.loadData(this.list)
        }

      })
    },




    selectChange(row) {
      this.$refs.xGrid.clearActived() // 清除单元格激活状态
      this.$refs.xGrid.setActiveCell(row.row, row.column.property) // 设置单元格为激活状态
      null2str(row.row)
    },
    getHeight() {
      this.height = window.innerHeight - 190
    },
    toolbarButtonClickEvent(code) {
      const {
        insertRecords,
        removeRecords,
        updateRecords
      } = this.$refs.xGrid.getRecordset()
      switch (code) {
        case 'insert':
          if(this.request.dwbm==='' ||this.request.dwbm===null){
            this.$message({ message: '请选择需求单位！', type: 'warning' })
            return
          }
          this.$refs.xGrid.insertAt({
            'dwbm':this.request.dwbm,
            'fzry': this.name,
          }, -1).then(({ row }) => {
            this.$refs.xGrid.setActiveRow(row)
          })
          break
        case 'delete':
          this.$confirm('删除, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then((type) => {
            this.$refs.xGrid.removeCheckboxRow()
          })
          break
        case 'save':


          if (removeRecords.length !== 0) {
            delXqdwcjcd(removeRecords).then((response) => {
              if (response.success) {
                for (let i = 0; i < this.list.length; i++) {
                  if (removeRecords.indexOf(this.list[i]) !== -1) {
                    this.list.splice(i, 1)
                    i--
                  }
                }
                this.$message({ message: '保存成功！', type: 'success' })
                const xTable = this.$refs.xGrid
                xTable.loadData(this.initList())

              }
            })
          }



          if (updateRecords.length !== 0) {
            updateXqdwcjcd(updateRecords).then((response) => {
              if (response.success) {
                const xTable = this.$refs.xGrid
                xTable.loadData(this.initList())
                this.$message({message: '保存成功！', type: 'success'})
              }
            })
          }
          if (insertRecords.length !== 0) {
            saveXqdwcjcd(insertRecords).then((response) => {
              if (response.success) {
                this.list = this.list.concat(insertRecords)
                const xTable = this.$refs.xGrid
                xTable.loadData(this.initList())
                this.$message({ message: '保存成功！', type: 'success' })
              }
            })
          }
          this.$message(
            `新增 ${insertRecords.length} 条，删除 ${removeRecords.length} 条，更新 ${updateRecords.length} 条`
          )
          this.clickList = []
          break
      }
    }
  }
}
</script>
<style lang="scss" scoped >

.el-header{margin:0;padding: 5px;height:auto;
  .el-input{
    width: 140px;
  }
  .el-select{
    width: 140px;
  }

}
.el-container{padding: 0;margin:0;}
.el-main{padding: 0;}
.el-col{padding: 0;height: 32px;}
.el-aside{background: #fff;padding: 0}
.el-container{padding: 0}
.el-row {}
.el-row:last-child {margin-bottom: 0; }

.tableStyles{
  background: #0a76a4;
}

.my-dropdown {
  width: 400px;
  height: 400px;
  background-color: #fff;
  border: 1px solid #dcdfe6;
  box-shadow: 0 0 6px 2px rgba(0, 0, 0, 0.1);
  font-size: 12px;

}
.mytable1{

}
.borderClass{

}
.vxe-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.el-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.keyword-lighten {
  color: #000;
  background-color: #FFFF00;
}

.vxe-textarea--inner {
  line-height: inherit;
}
.el-form-item__label-wrap {
  margin-left: 0px !important;
  float: left;
}
.fontClass{
  font-size: 12px;
  font-weight: bold;
}


</style>
